// Beispiele zu String-Verarbeitung: Klasse String
// Autor: M. Scheer

public class StringTest {
	// Instanzvariablen
   String vorname = "Anton";
   String nachname = new String("Meier");
   String name, z1, z2, z3;
   
   // Konstruktor
   public StringTest() {
      name = nachname + ", " + vorname;      
   }

   // Instanzmethoden      
   // Verketten
   public void verketten () {
      name = name.concat(" Hugo");
      System.out.println("Ausgabe Verkettung             : " + name);
      System.out.println();
   }
      
   // Zeichenkettenlnge
   public void zeichenLaenge() {
      System.out.println("Ausgabe Zeichenlnge           : " + name.length());
      System.out.println();
   }
      
   // Extrahieren
   public void extrahiere() {
      System.out.println("Extrahieren:");
      System.out.println("Zeichen an der 4. Stelle       : " + name.charAt(2));
      System.out.println("Teilstring 8. bis 12. Stelle   : " + name.substring(7, 12));
      System.out.println();
   }
      
   // Vergleichen
   public void vergleichen() {
      System.out.println("Zeichenketten vergleichen:");
      z1 = "Fritz";
      z2 = "Fritz";
      z3 = new String("Fritz");
      
      System.out.println("Vergleichen:");
      // Folgende Vergleiche liefert nicht immer zwingend ein true,
      // deshalb sollten Vergleiche von Strings immer mit der 
      // Methode equals() erfolgen
      if (z1 == z2) System.out.println("z1 und z2 verweisen auf dasselbe Objekt");
      if (z1 == z3) System.out.println("z1 und z3 verweisen auf dasselbe Objekt");
      else          System.out.println("z1 und z3 verweisen NICHT auf dasselbe Objekt");
      // Besser ist:
      if (z1.equals(z3)) System.out.println("z1 und z3 reprsentieren dieselbe Zeichenkette");
      System.out.println();
   }
   
   public void teilStrings() {
      System.out.println("Teilstrings:");
      if (name.startsWith("Meier")) System.out.println("Name beginnt mit \"Meier\"");
   
      if (vorname.compareTo("Hugo") < 0) System.out.println("\"Anton\" ist lnger als \"Hugo\"");
      System.out.println();
   }

   // Suchen
   public void zeichenSuchen() {
      System.out.println("Suchen:");
      System.out.println("Position erstes Auftreten von 'r'      : " + (name.indexOf('r') + 1));
      // Funktioniert auch mit dem Code von 'r' = (114)  
      System.out.println("Position erstes Auftreten von 'r'      : " + (name.indexOf(114) + 1));

      System.out.println("erstes Auftreten von 'e' nach Pos. 3   : " + (name.indexOf('e', 2) + 1));
      System.out.println("erstes Auftreten von 'ton' nach Pos. 2 : " + (name.indexOf("ton", 1) + 1));
      System.out.println();
   }
   
   // Ersetzen
   public void zeichenErsetzen() {
      System.out.println("Ersetzen:");
      System.out.println("alle 'e' werden durch 'a' ersetzt      : " + name.replace('e', 'a'));
      System.out.println("Zeichenkette selbst bleibt unverndert : " + name);
      System.out.println("Alles in Grobuchstaben konvertieren   : " + name.toUpperCase());
      System.out.println("Zeichenkette selbst bleibt unverndert : " + name);
      System.out.println();
   }
      
   // Konvertieren
   public void konvertierenInString() {
      System.out.println("Konvertieren:");
      // mit einer Klassenmethode
      z1 = String.valueOf(123.789);
      // pragmatisch: Verkettung mit einer leeren Zeichenfolge
      z2 = 123.789 + "" ;
      System.out.println("Dez.-Zahl als Zeichenkette, . ersetzt   : " + z2.replace('.', ','));      
      System.out.println();
   }
}